Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/BrokerServiceImpl.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/BrokerServiceImpl.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/BrokerServiceImpl.java	(revision 61441)
@@ -2,12 +2,12 @@
 
 import com.fasterxml.jackson.databind.JsonNode;
 import com.fasterxml.jackson.databind.ObjectMapper;
-import eu.dnetlib.domain.data.Repository;
 import eu.dnetlib.repo.manager.domain.BrokerException;
 import eu.dnetlib.repo.manager.domain.RepositorySnippet;
 import eu.dnetlib.repo.manager.domain.Term;
 import eu.dnetlib.repo.manager.domain.Tuple;
 import eu.dnetlib.repo.manager.domain.broker.*;
+import org.apache.commons.lang.NotImplementedException;
 import org.json.JSONException;
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.beans.factory.annotation.Value;
@@ -44,11 +44,11 @@
             .getLogger(BrokerServiceImpl.class);
 
     @Autowired
-    RestTemplate restTemplate ;
+    RestTemplate restTemplate;
 
     private HttpHeaders httpHeaders;
 
-    private HashMap<String,Term> topics = new HashMap<String, Term>();
+    private HashMap<String, Term> topics = new HashMap<String, Term>();
 
     @Autowired
     private EmailUtils emailUtils;
@@ -60,29 +60,29 @@
         httpHeaders.set("Content-Type", "application/json");
 
         LOGGER.debug("Init dnet topics!");
-        try (InputStream is = new URL(topicsURL).openStream() ){
+        try (InputStream is = new URL(topicsURL).openStream()) {
             ObjectMapper mapper = new ObjectMapper();
             JsonNode root = mapper.readTree(is);
-            for (JsonNode term : root.path("terms") )
+            for (JsonNode term : root.path("terms"))
                 topics.put(term.path("code").textValue(), parseTerm(term));
         } catch (IOException e) {
-            LOGGER.debug("Exception on initDnetTopicsMap" , e);
+            LOGGER.debug("Exception on initDnetTopicsMap", e);
             emailUtils.reportException(e);
         }
     }
 
     private Term parseTerm(JsonNode term) {
-        return new Term(term.path("englishName").textValue(),term.path("nativeName").textValue(),
-                term.path("encoding").textValue(),term.path("code").textValue());
+        return new Term(term.path("englishName").textValue(), term.path("nativeName").textValue(),
+                term.path("encoding").textValue(), term.path("code").textValue());
     }
 
 
     @Override
-    public DatasourcesBroker getDatasourcesOfUser(String user,String includeShared,String includeByOthers) throws JSONException {
+    public DatasourcesBroker getDatasourcesOfUser(String user, String includeShared, String includeByOthers) throws JSONException {
         long start = System.currentTimeMillis();
         DatasourcesBroker ret = new DatasourcesBroker();
         try {
-            ret.setDatasourcesOfUser(getDatasourcesOfUserType(repoAPI.getRepositoriesSnippetOfUser(user,"0","100")));
+            ret.setDatasourcesOfUser(getDatasourcesOfUserType(repoAPI.getRepositoriesSnippetsOfUser(user, "0", "100")));
             //TODO fix bug when values are true
 //            if (Boolean.parseBoolean(includeShared)) {
 //                List<String> sharedDatasourceIds = new ArrayList<String>();
@@ -92,12 +92,12 @@
 //            if (Boolean.parseBoolean(includeByOthers)) {
 //                ret.setDatasourcesOfOthers(getDatasourcesOfUserType(getRepositoriesOfUser(user)));
 //            }
-        } catch (BrokerException | IOException e) {
-            LOGGER.debug("Exception on getDatasourcesOfUser" , e);
+        } catch (Exception e) {
+            LOGGER.debug("Exception on getDatasourcesOfUser", e);
             emailUtils.reportException(e);
         }
         long end = System.currentTimeMillis();
-        System.out.println("Getting datasources of user in " + (end-start)+"ms");
+        System.out.println("Getting datasources of user in " + (end - start) + "ms");
         return ret;
     }
 
@@ -117,7 +117,7 @@
                     new ParameterizedTypeReference<List<BrowseEntry>>() {
                     });
         } catch (RestClientException e) {
-            LOGGER.debug("Exception on getTopicsForDatasource" , e);
+            LOGGER.debug("Exception on getTopicsForDatasource", e);
             emailUtils.reportException(e);
             throw new BrokerException(e);
         }
@@ -128,7 +128,7 @@
     @Override
     public EventsPage advancedShowEvents(String page,
                                          String size,
-                                         AdvQueryObject advQueryObject) throws BrokerException, JSONException ,IOException {
+                                         AdvQueryObject advQueryObject) throws BrokerException, JSONException, IOException {
 
         final String service = "/events/{page}/{pageSize}";
 
@@ -151,7 +151,7 @@
                     }
             );
         } catch (RestClientException e) {
-            LOGGER.debug("Exception on advancedShowEvents" , e);
+            LOGGER.debug("Exception on advancedShowEvents", e);
             emailUtils.reportException(e);
             throw new BrokerException(e);
         }
@@ -183,31 +183,11 @@
             }
         });
         long stop = System.currentTimeMillis();
-        System.out.println("getDatasourcesOfUserType returned in " + (stop-start) + "ms ");
+        System.out.println("getDatasourcesOfUserType returned in " + (stop - start) + "ms ");
 
         return entries;
     }
 
-    private List<Repository> getRepositoriesOfUser(String userEmail) throws JSONException {
-
-        int page = 0;
-        int size = 50;
-        List<Repository> rs ;
-        List<Repository> resultSet = new ArrayList<>();
-
-        while (true){
-            rs = repoAPI.getRepositoriesOfUser(userEmail, String.valueOf(page), String.valueOf(size));
-            resultSet.addAll(rs);
-            page+=1;
-            if(rs.size() == 0) break;
-        }
-        return resultSet;
-    }
-
-    private List<Repository> getRepositoriesByIds(List<String> sharedDatasourceIds) {
-        return null;
-    }
-
     @Override
     public EventsPage showEvents(String datasourceName,
                                  String topic,
@@ -230,7 +210,7 @@
                     new ParameterizedTypeReference<EventsPage>() {
                     });
         } catch (RestClientException e) {
-            LOGGER.debug("Exception on showEvents" , e);
+            LOGGER.debug("Exception on showEvents", e);
             emailUtils.reportException(e);
             throw new BrokerException(e);
         }
@@ -256,7 +236,7 @@
                     new ParameterizedTypeReference<Map<String, List<SimpleSubscriptionDesc>>>() {
                     });
         } catch (RestClientException e) {
-            LOGGER.debug("Exception on getSimpleSubscriptionsOfUser" , e);
+            LOGGER.debug("Exception on getSimpleSubscriptionsOfUser", e);
             emailUtils.reportException(e);
             throw new BrokerException(e);
         }
@@ -266,8 +246,8 @@
     @Override
     public Map<String, List<SimpleSubscriptionDesc>> getSimpleSubscriptionsOfUserByRepoId(String userEmail, String repoId) throws BrokerException {
         Map<String, List<SimpleSubscriptionDesc>> subscriptionsOfUser = getSimpleSubscriptionsOfUser(userEmail);
-
-        return null;
+        throw new NotImplementedException();
+//        return null;
     }
 
     @Override
@@ -292,7 +272,7 @@
                     new ParameterizedTypeReference<Subscription>() {
                     });
         } catch (RestClientException e) {
-            LOGGER.debug("Exception on OpenaireSubscription" , e);
+            LOGGER.debug("Exception on OpenaireSubscription", e);
             emailUtils.reportException(e);
             throw new BrokerException(e);
         }
@@ -316,15 +296,15 @@
                     new ParameterizedTypeReference<Void>() {
                     });
         } catch (RestClientException e) {
-            LOGGER.debug("Exception on unsubscribe" , e);
+            LOGGER.debug("Exception on unsubscribe", e);
             emailUtils.reportException(e);
             throw new BrokerException(e);
         }
-        return new ResponseEntity<>("OK",HttpStatus.OK);
+        return new ResponseEntity<>("OK", HttpStatus.OK);
     }
 
     @Override
-    public Subscription getSubscription( String subscriptionId) throws BrokerException {
+    public Subscription getSubscription(String subscriptionId) throws BrokerException {
         final String service = "/subscriptions/" + subscriptionId;
 
         //build the uri params
@@ -340,7 +320,7 @@
                     new ParameterizedTypeReference<Subscription>() {
                     });
         } catch (RestClientException e) {
-            LOGGER.debug("Exception on getSubscription" , e);
+            LOGGER.debug("Exception on getSubscription", e);
             emailUtils.reportException(e);
             throw new BrokerException(e);
         }
@@ -360,7 +340,7 @@
         UriComponents uriComponents = UriComponentsBuilder
                 .fromHttpUrl(openairePath + "/notifications/")
                 .path("/{id}/{page}/{size}/")
-                .build().expand(subscriptionId,page, size).encode();
+                .build().expand(subscriptionId, page, size).encode();
 
         ResponseEntity<EventsPage> resp;
         try {
@@ -371,7 +351,7 @@
                     new ParameterizedTypeReference<EventsPage>() {
                     });
         } catch (RestClientException e) {
-            LOGGER.debug("Exception on getNotificationsBySubscriptionId" , e);
+            LOGGER.debug("Exception on getNotificationsBySubscriptionId", e);
             emailUtils.reportException(e);
             throw new BrokerException(e);
         }
@@ -383,16 +363,16 @@
             throws BrokerException {
 
         Map<String, List<SimpleSubscriptionDesc>> simpleSubs = getSimpleSubscriptionsOfUser(userEmail);
-        Map<String,List<Subscription>> subs = new HashMap<>();
+        Map<String, List<Subscription>> subs = new HashMap<>();
         List<Subscription> subscriptions = null;
 
-        for(String s:simpleSubs.keySet()){
+        for (String s : simpleSubs.keySet()) {
             List<SimpleSubscriptionDesc> simpleSubscriptionDescs = simpleSubs.get(s);
-            for(SimpleSubscriptionDesc simpleSubscriptionDesc : simpleSubscriptionDescs) {
+            for (SimpleSubscriptionDesc simpleSubscriptionDesc : simpleSubscriptionDescs) {
                 subscriptions = new ArrayList<>();
                 subscriptions.add(getSubscription(simpleSubscriptionDesc.getId()));
             }
-            subs.put(s,subscriptions);
+            subs.put(s, subscriptions);
         }
         return subs;
     }
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AaiRoleMappingService.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AaiRoleMappingService.java	(nonexistent)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AaiRoleMappingService.java	(revision 61441)
@@ -0,0 +1,120 @@
+package eu.dnetlib.repo.manager.service.security;
+
+import org.apache.log4j.Logger;
+import org.springframework.beans.factory.annotation.Value;
+import org.springframework.security.core.GrantedAuthority;
+import org.springframework.security.core.authority.SimpleGrantedAuthority;
+import org.springframework.stereotype.Service;
+
+import java.net.URLEncoder;
+import java.util.Collection;
+import java.util.Objects;
+import java.util.stream.Collectors;
+
+@Service("roleMappingService")
+public class AaiRoleMappingService implements RoleMappingService {
+
+    private static final Logger logger = Logger.getLogger(AaiRoleMappingService.class);
+
+    @Value("${aai.registry.production:true}")
+    private boolean production;
+
+
+    private String createRepoRoleName(String prefix, String repoId) {
+        return prefix + "." + repoId.replace(":", "$");
+    }
+
+    @Override
+    public String getRepoNameWithoutType(String fullName, String prefix) {
+        if (fullName != null && prefix != null && fullName.startsWith(prefix)) {
+            return fullName.substring(prefix.length());
+        }
+        return null;
+    }
+
+    @Override
+    public String getRepoIdByRoleId(String roleId) {
+        if (!roleActive(roleId)) {
+            return null;
+        }
+        return roleId.replaceFirst(".*datasource\\.", "").replace("$", ":");
+    }
+
+    @Override
+    public Collection<String> getRepoIdsByRoleIds(Collection<String> roleIds) {
+        return roleIds
+                .stream()
+                //.filter(this::roleActive) //  implicitly executed in the next statement
+                .map(this::getRepoIdByRoleId)
+                .filter(Objects::nonNull)
+                .collect(Collectors.toList());
+    }
+
+    @Override
+    public String getRoleIdByRepoId(String repoId) {
+        String roleId = "";
+        String prefix = (production ? "" : "beta.") + "datasource";
+        if (repoId != null) {
+            roleId = createRepoRoleName(prefix, repoId);
+            return roleId;
+        } else {
+            return null;
+        }
+
+    }
+
+    @Override
+    public Collection<String> getRoleIdsByRepoIds(Collection<String> repoIds) {
+        return repoIds
+                .stream()
+                .map(this::getRoleIdByRepoId)
+                .filter(Objects::nonNull)
+                .collect(Collectors.toList());
+    }
+
+    @Override
+    public String convertAuthorityIdToRepoId(String authorityId) {
+        String repo = "";
+        if (authorityId != null && roleActive(authorityId)) {
+            repo = authorityId
+                    .replaceFirst(".*datasource\\.", "")
+                    .replace("$", ":")
+                    .toLowerCase();
+        }
+        return repo;
+    }
+
+    @Override
+    public String convertAuthorityToRepoId(GrantedAuthority authority) {
+        return convertAuthorityIdToRepoId(authority.toString());
+    }
+
+    @Override
+    public String convertRepoIdToAuthorityId(String repoId) {
+        StringBuilder roleBuilder = new StringBuilder();
+        String role = "";
+        if (repoId != null) {
+            roleBuilder.append(production ? "" : "beta.");
+            roleBuilder.append("datasource.");
+            roleBuilder.append(repoId.replace(":", "$"));
+            role = roleBuilder.toString().replace(".", "_").toUpperCase();
+        }
+        return role;
+    }
+
+    @Override
+    public String convertRepoIdToEncodedAuthorityId(String repoId) {
+        return URLEncoder.encode(convertRepoIdToAuthorityId(repoId));
+    }
+
+    @Override
+    public SimpleGrantedAuthority convertRepoIdToAuthority(String repoId) {
+        String role = convertRepoIdToEncodedAuthorityId(repoId);
+        return new SimpleGrantedAuthority(role);
+    }
+
+    private boolean roleActive(String roleId) {
+        return (production && !roleId.toLowerCase().startsWith("beta."))
+                || (!production && roleId.toLowerCase().startsWith("beta."));
+    }
+}
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AuthorizationService.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AuthorizationService.java	(nonexistent)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AuthorizationService.java	(revision 61441)
@@ -0,0 +1,69 @@
+package eu.dnetlib.repo.manager.service.security;
+
+import eu.dnetlib.repo.manager.domain.dto.User;
+import eu.dnetlib.repo.manager.exception.ResourceNotFoundException;
+
+import java.util.Collection;
+import java.util.List;
+
+public interface AuthorizationService {
+
+    /**
+     * @param type
+     * @param id
+     * @return
+     */
+    String member(String type, String id); //TODO: use or delete
+
+    /**
+     * @param id Resource Id to check.
+     * @return Checks if a user is a member of a resource.
+     */
+    boolean isMemberOf(String id);
+
+
+    /**
+     * Returns a list of admins of the resource.
+     *
+     * @param repoId
+     * @return
+     */
+    List<User> getAdminsOfRepo(String repoId);
+
+    /**
+     * Add a user as admin to a resource.
+     *
+     * @param id    Resource id
+     * @param email User email
+     * @return
+     * @throws ResourceNotFoundException
+     */
+    boolean addAdmin(String id, String email) throws ResourceNotFoundException;
+
+    /**
+     * Remove user from resource admins.
+     *
+     * @param id    Resource id
+     * @param email User email
+     * @return
+     * @throws ResourceNotFoundException
+     */
+    boolean removeAdmin(String id, String email) throws ResourceNotFoundException;
+
+
+    /**
+     * Returns the roles of the authenticated user.
+     * 
+     * @return
+     */
+    Collection<String> getUserRoles();
+
+    /**
+     * Returns the roles of the user with the given email.
+     *
+     * @param email
+     * @return
+     */
+    Collection<String> getUserRoles(String email);
+
+}
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AuthorizationServiceImpl.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AuthorizationServiceImpl.java	(nonexistent)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AuthorizationServiceImpl.java	(revision 61441)
@@ -0,0 +1,149 @@
+package eu.dnetlib.repo.manager.service.security;
+
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import eu.dnetlib.repo.manager.domain.dto.User;
+import eu.dnetlib.repo.manager.exception.ResourceNotFoundException;
+import eu.dnetlib.repo.manager.service.aai.registry.AaiRegistryService;
+import org.mitre.openid.connect.model.OIDCAuthenticationToken;
+import org.mitre.openid.connect.model.UserInfo;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.security.core.context.SecurityContextHolder;
+import org.springframework.stereotype.Service;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.List;
+
+@Service("authorizationService")
+public class AuthorizationServiceImpl implements AuthorizationService {
+
+    public static final String SUPER_ADMINISTRATOR = "SUPER_ADMINISTRATOR";
+    public static final String CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR = "CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR";
+    public static final String REGISTERED_USER = "REGISTERED_USER";
+
+    private final RoleMappingService roleMappingService;
+    private final AaiRegistryService aaiRegistryService;
+    private final AuthoritiesUpdater authoritiesUpdater;
+
+    @Autowired
+    AuthorizationServiceImpl(RoleMappingService roleMappingService, AaiRegistryService aaiRegistryService,
+                             AuthoritiesUpdater authoritiesUpdater) {
+        this.roleMappingService = roleMappingService;
+        this.aaiRegistryService = aaiRegistryService;
+        this.authoritiesUpdater = authoritiesUpdater;
+    }
+
+    private String mapType(String type) {
+        if (type.equals("datasource")) {
+            type = "datasource";
+        }
+        return type;
+    }
+
+    /**
+     * Type = DATASOURCE
+     */
+    @Override
+    public String member(String type, String id) {
+        return mapType(type).toUpperCase() + "_" + id.toUpperCase();
+    }
+
+    @Override
+    public boolean isMemberOf(String repoId) {
+        String repoRole = roleMappingService.convertRepoIdToEncodedAuthorityId(repoId);
+        return SecurityContextHolder.getContext().getAuthentication().getAuthorities()
+                .parallelStream().anyMatch(authority -> authority.toString().equals(repoRole));
+    }
+
+    @Override
+    public List<User> getAdminsOfRepo(String repoId) {
+        List<String> userList = new ArrayList<>();
+
+        // find couId by role name
+        String role = roleMappingService.getRoleIdByRepoId(repoId);
+        Integer couId = aaiRegistryService.getCouId(role);
+        if (couId != null) {
+            JsonArray users = aaiRegistryService.getUsersByCouId(couId);
+            for (JsonElement jsonElement : users) {
+                userList.add(jsonElement.toString());
+            }
+        }
+        return aaiRegistryService.getUsers(couId);
+    }
+
+
+    @Override
+    public boolean addAdmin(String id, String email) throws ResourceNotFoundException {
+        Integer coPersonId = aaiRegistryService.getCoPersonIdByEmail(email);
+        if (coPersonId != null) {
+            String role = roleMappingService.getRoleIdByRepoId(id);
+            Integer couId = aaiRegistryService.getCouId(role);
+            if (couId != null) {
+                Integer roleId = aaiRegistryService.getRoleId(coPersonId, couId);
+                aaiRegistryService.assignMemberRole(coPersonId, couId, roleId);
+
+                // Add role to user current authorities
+                authoritiesUpdater.addRole(email, roleMappingService.convertRepoIdToAuthority(id));
+
+                return true;
+            } else {
+                throw new ResourceNotFoundException("Cannot find CouId for role: " + role);
+            }
+        } else {
+            throw new ResourceNotFoundException("Cannot find coPersonId for user with email: " + email);
+        }
+    }
+
+    @Override
+    public boolean removeAdmin(String id, String email) throws ResourceNotFoundException {
+        Integer coPersonId = aaiRegistryService.getCoPersonIdByEmail(email);
+        if (coPersonId != null) {
+            String role = roleMappingService.getRoleIdByRepoId(id);
+            Integer couId = aaiRegistryService.getCouId(role);
+            Integer roleId = null;
+            if (couId != null) {
+                roleId = aaiRegistryService.getRoleId(coPersonId, couId);
+            }
+            if (couId != null && roleId != null) {
+                aaiRegistryService.removeMemberRole(coPersonId, couId, roleId);
+
+                // Remove role from user current authorities
+                authoritiesUpdater.removeRole(email, roleMappingService.convertRepoIdToAuthority(id));
+
+                return true;
+            } else {
+                throw new ResourceNotFoundException("Cannot find CouId for role: " + role);
+            }
+        } else {
+            throw new ResourceNotFoundException("Cannot find coPersonId for user with email: " + email);
+        }
+    }
+
+    @Override
+    public Collection<String> getUserRoles() {
+        List<String> roles;
+        JsonArray entitlements;
+        UserInfo userInfo = ((OIDCAuthenticationToken) SecurityContextHolder.getContext().getAuthentication()).getUserInfo();
+        if (userInfo.getSource().getAsJsonArray("edu_person_entitlements") != null) {
+            entitlements = userInfo.getSource().getAsJsonArray("edu_person_entitlements");
+        } else if (userInfo.getSource().getAsJsonArray("eduperson_entitlement") != null) {
+            entitlements = userInfo.getSource().getAsJsonArray("eduperson_entitlement");
+        } else {
+            entitlements = new JsonArray();
+        }
+        roles = AuthoritiesMapper.entitlementRoles(entitlements);
+        return roles;
+    }
+
+    @Override
+    public Collection<String> getUserRoles(String email) {
+        int coPersonId = aaiRegistryService.getCoPersonIdByEmail(email);
+        List<Integer> list = new ArrayList<>();
+        for (JsonElement element : aaiRegistryService.getRolesWithStatus(coPersonId, AaiRegistryService.RoleStatus.ACTIVE)) {
+            list.add(element.getAsJsonObject().get("CouId").getAsInt());
+        }
+        return aaiRegistryService.getCouNames(list).values();
+    }
+
+}
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/RoleMappingService.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/RoleMappingService.java	(nonexistent)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/RoleMappingService.java	(revision 61441)
@@ -0,0 +1,74 @@
+package eu.dnetlib.repo.manager.service.security;
+
+import org.springframework.security.core.GrantedAuthority;
+import org.springframework.security.core.authority.SimpleGrantedAuthority;
+
+import java.util.Collection;
+
+public interface RoleMappingService {
+
+    /**
+     * @param fullName
+     * @param prefix
+     * @return
+     */
+    String getRepoNameWithoutType(String fullName, String prefix);
+
+    /**
+     * @param roleId Role Id
+     * @return Converts {@param roleId} to a repo Id.
+     */
+    String getRepoIdByRoleId(String roleId);
+
+    /**
+     *
+     * @param roleIds Collection of roles
+     * @return Converts {@param roleIds} to a repo Ids.
+     */
+    Collection<String> getRepoIdsByRoleIds(Collection<String> roleIds);
+
+    /**
+     * @param repoId Repository Id
+     * @return Converts {@param repoId} to a role Id.
+     */
+    String getRoleIdByRepoId(String repoId);
+
+    /**
+     * @param repoIds Collection of Repository Ids
+     * @return Converts {@param repoIds} to role Ids.
+     */
+    Collection<String> getRoleIdsByRepoIds(Collection<String> repoIds);
+
+    /**
+     * @param authorityId Authority Id
+     * @return Converts {@param authorityId} to repo Id.
+     */
+    String convertAuthorityIdToRepoId(String authorityId);
+
+    /**
+     * @param authority Granted authority
+     * @return Converts {@param authority} to repo Id.
+     */
+    String convertAuthorityToRepoId(GrantedAuthority authority);
+
+    /**
+     * @param repoId Repository Id
+     * @return
+     */
+    String convertRepoIdToAuthorityId(String repoId);
+
+    /**
+     * @param repoId Repository Id
+     * @return Converts {@param repoId} to {@link String} role id url encoded ($ -> %24)
+     * // TODO: remove role encoding and perform url decoding when mapping authorities. (Must be performed in all OpenAIRE projects because of Redis)
+     */
+    String convertRepoIdToEncodedAuthorityId(String repoId);
+
+    /**
+     * @param repoId Repository Id
+     * @return Converts {@param repoId} to {@link SimpleGrantedAuthority} with the role url encoded ($ -> %24)
+     * // TODO: remove role encoding and perform url decoding when mapping authorities. (Must be performed in all OpenAIRE projects because of Redis)
+     */
+    SimpleGrantedAuthority convertRepoIdToAuthority(String repoId);
+
+}
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AuthoritiesMapper.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AuthoritiesMapper.java	(nonexistent)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/security/AuthoritiesMapper.java	(revision 61441)
@@ -0,0 +1,73 @@
+package eu.dnetlib.repo.manager.service.security;
+
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import org.apache.log4j.Logger;
+import org.springframework.security.core.GrantedAuthority;
+import org.springframework.security.core.authority.SimpleGrantedAuthority;
+
+import java.net.URLDecoder;
+import java.util.*;
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
+
+public class AuthoritiesMapper {
+
+    private static final Logger logger = Logger.getLogger(AuthoritiesMapper.class);
+    private static final String ENTITLEMENT_REGEX = "urn:geant:openaire[.]eu:group:([^:]*):?(.*)?:role=member#aai[.]openaire[.]eu";
+
+    private AuthoritiesMapper() {
+    }
+
+    public static Collection<GrantedAuthority> map(JsonArray entitlements) {
+        HashSet<GrantedAuthority> authorities = new HashSet<>();
+        entityRoles(entitlements, authorities);
+        return authorities;
+    }
+
+    public static List<String> entitlementRoles(JsonArray entitlements) {
+        List<String> roles = new ArrayList<>();
+        if (entitlements != null) {
+            for (JsonElement obj : entitlements) {
+                Matcher matcher = Pattern.compile(ENTITLEMENT_REGEX).matcher(obj.getAsString());
+                if (matcher.find()) {
+                    StringBuilder sb = new StringBuilder();
+                    if (matcher.group(1) != null && matcher.group(1).length() > 0) {
+                        sb.append(matcher.group(1));
+                    }
+                    if (matcher.group(2).length() > 0) {
+                        sb.append(":");
+                        sb.append(matcher.group(2));
+                    }
+                    String role = sb.toString().replace("+", " ");
+                    roles.add(URLDecoder.decode(role));
+                }
+            }
+        }
+        return roles;
+    }
+
+    private static void entityRoles(JsonArray entitlements, Set<GrantedAuthority> authorities) {
+        if (entitlements != null) {
+            for (JsonElement obj : entitlements) {
+                Matcher matcher = Pattern.compile(ENTITLEMENT_REGEX).matcher(obj.getAsString());
+                if (matcher.find()) {
+                    StringBuilder sb = new StringBuilder();
+                    if (matcher.group(1) != null && matcher.group(1).length() > 0) {
+                        sb.append(matcher.group(1).replace("+-+", "_").replaceAll("[+.]", "_").toUpperCase());
+                    }
+                    if (matcher.group(2).length() > 0) {
+                        sb.append("_");
+                        if (matcher.group(2).equals("admins")) {
+                            sb.append("MANAGER");
+                        } else {
+                            sb.append(matcher.group(2).toUpperCase());
+                        }
+                    }
+                    authorities.add(new SimpleGrantedAuthority(sb.toString()));
+                }
+            }
+        }
+    }
+
+}
